eval '(exit $?0)' && eval 'PERLDB_OPTS="N f=26";export PERLDB_OPTS;PERL=`which perl5`; exec $PERL -wS $0 ${1+"$@"}'
    & eval 'setenv PERLDB_OPTS "N f=26"; setenv PERL `which perl5`; exec $PERL -wS $0 $argv:q'
    if 0;

### Local Variables: ***
### mode:perl ***
### comment-column:0 ***
### comment-start: "### " ***
### comment-end: "***" ***
### End: ***
#
# ****************DO NOT MOVE OR CHANGE LINES ABOVE THIS*********************
#
# The first set of lines runs perl from any shell. The second set of lines
# identifies the rest of the file as PERL for EMACS autoformatting.
# See end of copyright for more information.
#
# 
# -------------------------------------------------------------------
#                                   X-BONE
#
#                          http://www.isi.edu/xbone
#                USC Information Sciences Institute (USC/ISI)
#                   Marina del Rey, California 90292, USA
#                          Copyright (c) 1998-2005
# 
# -------------------------------------------------------------------
#
# Copyright (c) 1998-2005 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation in source and binary forms for non-commercial
# purposes and without fee is hereby granted, provided that the above
# copyright notice appear in all copies and that both the copyright
# notice and this permission notice appear in supporting
# documentation, and that any documentation, advertising materials,
# and other materials related to such distribution and use acknowledge
# that the software was developed by the University of Southern
# California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived
# from this software without specific prior written permission.
# 
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT
# THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS
# PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so
# noted when applicable.
#
# -------------------------------------------------------------------
#
# Effort partly sponsored by the Defense Advanced Research Projects
# Agency (DARPA) and Air Force Research Laboratory, Air Force Materiel
# Command, USAF, under agreement numbers F30602-98-1-0200 (X-Bone) and
# F30602-01-2-0529 (DynaBone). The views and conclusions contained
# herein are those of the authors and should not be interpreted as
# necessarily representing the official policies or endorsements,
# either expressed or implied, of the Defense Advanced Research
# Projects Agency (DARPA), the Air Force Research Laboratory, or the
# U.S. Government.
#
# This work was partly supported by the NSF STI-XTEND (ANI-0230789)
# and NETFS (ANI-0129689) projects. Any opinions, findings, and
# conclusions or recommendations expressed in this material are those
# of the authors and do not necessarily reflect the views of the
# National Science Foundation.
#
# -------------------------------------------------------------------
#  $RCSfile: xb-ldap-config.pl,v $
#
# $Revision: 1.22 $
#   $Author: pingali $
#     $Date: 2005/04/21 05:41:52 $
#    $State: Exp $
# ----------------------------------------------------------------------------
#
############################################################
#
# The first lines start PERL on any system where perl is in the path.
# This is a modified version of the "start perl" script
# provided in the PERL man pages, which starts perl
# on the remainder of the file regardless of whether it
# is run under sh, csh, or perl.
#
# This version is modified to dynamically locate the
# perl path, rather than requiring it be hard-coded.
#
# setenv PERLDB_OPTS "N f=26"
#
# Must be set before perl starts!
#
# N 	: Nonstop (noninteractive)
# f=26	: frame=26 = 16 + 8 + 2,
#		2 = entry and exit,
#		!4 = don't print args to functions
#		8= enabled overloaded stringify and tied FETCH
#		16= print return values from subroutines
#
# note - '-T' (TAINT) switch is not included, because 'which' often
# returns a version of perl that isn't secure. don't worry about it.
#
############################################################
# PERL CODE STARTS HERE
############################################################

# 
# xb-ldap-config.pl installs or uninstalls xbone-specific
# openldap configuration file. 
#

use strict;
use sigtrap;

use Data::Dumper;
use Cwd;
use FindBin; 

my $xbprefix = "/usr/local/etc/xbone";
my $xboneconf       = $xbprefix . "/xbone.conf";
my $xboneslapconf   = $xbprefix . "/openldap/slapd-xbone.conf";  
my $template        = $xbprefix . "/openldap/slapd-xbone.conf.template";  
my $slavelocalldif  = $xbprefix . "/openldap/slave-init-local.ldif"; 
my $slavegloballdif = $xbprefix . "/openldap/slave-init-global.ldif"; 
my $xbonelocalldif  = $xbprefix . "/openldap/xbone-ldap-local.ldif"; 
my $xbonegloballdif = $xbprefix . "/openldap/xbone-ldap-global.ldif"; 

my $slapdconf="/usr/local/etc/openldap/slapd.conf";
if (! -e "$slapdconf"){ $slapdconf = "/etc/openldap/slapd.conf";} 

#=> Find where the various executables are...
my ($slurpd, $slapd, $slapcat, $slapadd, $ldapadd, $ldapdelete, $ldapsearch) = (); 
my %varmap = (
	   "slurpd" => \$slurpd,
	   "slapd" => \$slapd, 
	   "slapcat" => \$slapcat, 
	   "slapadd" => \$slapadd, 
	   "ldapadd" => \$ldapadd, 
	   "ldapdelete" => \$ldapdelete, 
	   "ldapsearch" => \$ldapsearch, 
	   );
	   
my @path = ("/bin", "/sbin","/usr/bin","/usr/sbin",
	    "/usr/local/bin","/usr/local/sbin",
	    "/libexec", "/usr/libexec", "/usr/local/libexec",
            split(":", $ENV{PATH}));

foreach my $p (keys %varmap){
    my $found = 0; 
    foreach my $dir (@path){
	if(-e "$dir/$p" and -x "$dir/$p" ){ 
	    ${$varmap{$p}} = "$dir/$p";
	    $found = 1; 
	    last;
	}
    };
    die ("Unable to find $p in path or $p does not have the right permissions") 
        if ($found == 0);
}


# => Other Variables....
my $home = $ENV{"HOME"}; 
my $host = `hostname`; 
chomp($host); 
my $os = `uname -s`; 
chomp($os); 

my  %xbonevars = ( 
		"ca_cert" =>  "",
		"ca_path" =>  "",
		"node_cert" => "",
		"node_key" => "",
		);
my %replacement = (); 


# => Load an ldif file into the server. 
sub slapd_add ($$) { 
    
    my ($server, $file) = @_; 

    if ( ! -e "$home/.ldaprc" ){  
	print"$home/.ldaprc settings file must exist on host $host.\n"; 
	print "See /usr/local/xbone/doc/xbone-ldap.txt\n";
	die("add");
    }
    
    if ( ! -e $file ){  
	print "LDIF input file $file undefined\n";
	die ("add");
    }

    print "Connecting as the Manager user to LDAP server $server\n";
    my @cmd = ("$ldapadd", "-c", "-vx", "-H", "ldaps://$server", "-D",
	       "cn=Manager,ou=Users,ou=local,ou=xbone", "-W", "-f", "$file");

    system(@cmd) == 0 or
	print "Error while adding the LDIF content to the LDAP server\n" and 
	die ("add"); 
    
    return;
}


# => Show the xbone content of the LDAP server 
sub slapd_show($$;) { 
    
    my ($server, $oid) = @_; 

    if ( ! -e "$home/.ldaprc" ){  
	print"$home/.ldaprc settings file must exist on host $host.\n"; 
	print "See /usr/local/xbone/doc/xbone-ldap.txt\n";
	die("show");
    }
    
    if ( not defined $oid or $oid eq "" ){  
	$oid = "ou=local,ou=xbone"; 
    }

    print "Connecting as the XBoneUser user to LDAP server $server\n";
    my @cmd = ("$ldapsearch", "-vx", "-H", "ldaps://$server", "-D",
	       "cn=XBoneUser,ou=Users,ou=local,ou=xbone", "-W", "-b", 
	       "$oid", "(objectclass=*)" );

    #print "executing " . join (" ", @cmd); 

    system(@cmd) == 0 or 
	print "Error while executing ldapsearch\n" and 
	die ("show"); 
    
    return; 

}

# => Show the xbone content of the LDAP server 
sub slapd_init($$) { 
    
    my ($file, $oid) = @_; 
    
    if ( ! -e $file ){  
	print "LDIF input file $file undefined\n";
	die ("init");
    }
    my @cmd = ("$slapadd", "-c", "-w", "-r", "-i", "1", "-f", 
	       $slapdconf, "-b", $oid, "-l", $file);  

    #print "executing " . join (" ", @cmd); 
    
    eval { 
	system(@cmd) == 0 or
	    print "Error while executing slapadd\n" and 
	    die ("init"); 
    }; 
    return; 

}

# => Backup the database 
sub ldif($) { 
    
    my ($oid) = @_;     
    my @cmd = ("$slapcat", "-b", $oid);  
    eval { 
	system(@cmd) == 0 or
	    print "Error while executing slapadd\n" and 
	    die ("ldif"); 
    }; 
    return; 

}

# => Show the xbone content of the LDAP server 
sub slapd_delete($;$) { 
    
    my ($server, $oid) = @_; 
    
    if ( ! -e "$home/.ldaprc" ){  
	print "OpenLDAP application requires that $home/.ldaprc \n". 
	      "settings file must exist on host $host.\n". 
	      "See /usr/local/xbone/doc/xbone-ldap.txt\n";
	die("delete");
    }
    
    # if nothing specified, delete everything 
    if ( not defined $oid or $oid eq "" ){  
	print "Please specify the oid to be deleted ".
  	      "(e.g., ou=local,ou=xbone)\n";
	die("delete");
    }

    #/usr/local/bin/ldapdelete -r -vx -H ldaps://mtv.isi.edu -D
    # cn=Manager,ou=Users,ou=local,ou=xbone -W "ou=xbone"

    print "Connecting as the Manager user to LDAP server $server\n";
    my @cmd = ("$ldapdelete", "-W", "-vx", "-r", "-H",
	       "ldaps://$server", "-D",
	       "cn=Manager,ou=Users,ou=local,ou=xbone", $oid);

    #print "executing " . join (" ", @cmd); 
    
    eval { 
	system(@cmd) == 0 or
	    print "Error while executing ldapdelete\n" and 
	    die ("init"); 
    }; 
    # ignore the results 
    return; 

}

sub verify_ldaprc {

    my @keys = ("TLS_CACERT", "TLS_CAPATH", "TLS_CERT", "TLS_KEY");
    my %val = (); 
    my $key; 

    eval { 
       write_ldaprc(); # If it does not exist, create it

       open (IN, "< $home/.ldaprc" ) or die("file"); 
       while (<IN>){
           my $line =  $_;
           chomp($line);
           my $found = 0;
           foreach $key (@keys){
               if ( $line =~ /$key/ ) {
                   $found = 1;
                   last;
               }
           }
   
           next if ($found == 0);
   
           my @components = split (/\s+/, $line);
           $val{$components[0]} = $components[1];
       };
       close(IN);
   
       foreach $key (@keys){
          my $file = $val{$key}; 
          die("cert") if (not defined $file or ! -e $file or ! -r $file );
       }; 
   };

   if ($@){
           print "Error in $home/.ldaprc. Either\n\t(1) file does not exist".
                 " or\n\t(2) variables are unspecified ". 
                 " or\n\t(3) paths specified within the file do not ". 
                    "exist or are not readable\n"; 
   	   print "Check the path settings in $home/.ldaprc\n\n"; 
   	   print "xb-ldap-config can be used to create ldaprc\n";
   	   print "See example in /usr/local/xbone/doc/xbone-ldap.txt\n";
           die("verify");
   }
};


# => Extract the variables from the configuration $conf
sub read_xbone_conf {    
    
    my @keys = keys %xbonevars; 
    open (IN, "< $xboneconf" ) or 
	print "Unable to open $xboneconf\n"
	and die "conf";

    while (<IN>){
	my $line =  $_; 
	chomp($line); 

	my $found = 0; 
	foreach my $key (@keys){
	    if ( $line =~ /$key/ ) { 
		$found = 1; 
		last; 
	    }
	}

	next if ($found == 0); 

	my @components = split (/\s+/, $line); 	
	if ( defined $xbonevars{$components[0]} ){
	    $xbonevars{$components[0]} = $components[2]; 
	}	
    }
    close(IN); 

    %replacement = ( 
		     "TLSCACERTFILE" => $xbonevars{ca_cert},
		     "TLSCERTPATH" => $xbonevars{ca_path},
		     "TLSCERTFILE" => $xbonevars{node_cert},
		     "TLSKEYFILE" => $xbonevars{node_key},
		     "SERVER" => "ldap.xbone.net",
		     "GXBONE" => "#", 
		     "DIR" => $xbprefix . "/openldap", 
		     );
}; 



# => Write out the openldap file. 
sub write_openldap  {

    my @keys = keys %replacement; 

    open( IN, "< $template") || die ("Unable to open $template for reading"); 
    open( OUT, "> $xboneslapconf") || die ("Unable to open $xboneslapconf for writing"); 

    while (<IN>){
	my $line = $_; 
	foreach my $key (@keys){
	    $line =~ s/$key/$replacement{$key}/g; 
	};
	
	print OUT $line;
    };
    
    close IN; 
    close OUT; 
};

sub write_ldaprc (;$) {

    my ($force) = @_; 
    if ( not defined $force) { $force = 0; }

    my $ldaprc = "$home/.ldaprc";
    if ( ! -e $ldaprc or $force != 0 ) {

	open( OUT, "> $ldaprc") || 
	    die ("Unable to open $ldaprc for writing"); 

	print OUT "#\n";
	print OUT "# LDAP Defaults automatically generated by xb-ldap-config\n"; 
	print OUT "# Can be deleted any time\n";
	print OUT "\n\n";
	
	print OUT "TLS_CIPHER_SUITE HIGH:MEDIUM:+SSLv2\n";
	print OUT "TLS_REQCERT   demand\n";
	print OUT "TLS_CACERT    ".$replacement{TLSCACERTFILE}. "\n";
	print OUT "TLS_CAPATH    ".$replacement{TLSCERTPATH}. "\n";
	print OUT "TLS_CERT      ".$replacement{TLSCERTFILE}. "\n";
	print OUT "TLS_KEY       ".$replacement{TLSKEYFILE}. "\n";
	
	close(OUT);

    };

};



# => Install/uninstall openldap 
sub slapd_conf_modify ($) {

    my ($op) = @_; 
    
    die ("Incorrect operation $op") if ($op !~ /(add|del)/); 

    my $orig = $slapdconf; 
    my $new = $slapdconf . ".xbone"; 

    my $found = 0; 

    if ( ! -e $orig ) {
	print "slapd configuration file is not installed\n";
	die ("Slapd not installed"); 
    }

    # move the old slapd to the new slapd file. 
    if ( -e $new ) { unlink $new; }
    system '/bin/mv', $orig, $new;
    
    # copy from the old to the new and back but change the text in 
    # the process. 
    open( IN, "< $new") || die ("Unable to open $new for reading"); 
    open( OUT, "> $orig") || die ("Unable to open $orig for writing");
    while (<IN>){
	my $line = $_; 	
	
	# ignore irrelevant lines 
	if ($line !~ /($xboneslapconf)/){ 
	    print OUT $line;	
	    next;
	}
	    
	# line exists
	if ($op eq "add") {
	    print OUT $line;
	    $found = 1;
	} elsif ($op eq "del") {	    
	    $found = 1;
	}

    }
    if ( ($found == 0) and ($op eq "add") ){
	print OUT "include $xboneslapconf\n"; 
    }

    close(IN); 
    close (OUT);
    
    system "/bin/rm", $new; 
    
}; 

sub slapd_daemon ($){ 
    
    my ($op) = @_;
    my $arg = "";

    if ($op =~ /^(restart|start)$/) {
	$arg = "restart"; 
    } elsif ($op =~ /^(stop)$/) {
	$arg = "stop";
    } else {
	die ("unknown command");
    }
    
    eval { 
	my @cmd = ();
	
	if ($os =~ /FreeBSD/i) { 	    
	    @cmd = ( "/usr/local/etc/rc.d/slapd.sh", $arg); 
	} else { 
	    # Linux 
	    if ($arg eq "stop") {
		@cmd = ( "killall", "slapd");
	    }; # should there be something for start? 	    
	}
	system(@cmd) == 0 or 
	    print "Error while starting/stopping slapd\n" and 
	    die ("slapd"); 
    };

    return; 

}; 

sub cleanup_slapdb {
    #=> delete the old directories 
    if (-e "/var/db/openldap-xbone-slurpd") { 
	system "/bin/rm", "-rf", "/var/db/openldap-xbone-slurpd"; 
    }
    if (-e "/var/db/openldap-xbone-data") { 
	system "/bin/rm", "-rf", "/var/db/openldap-xbone-data"; 
    }
    if (-e "/var/run/openldap-xbone" ) { 
	system "/bin/rm", "-rf", "/var/run/openldap-xbone"; 
    }
};
    
sub create_slapdb {
    # create the them again
    system "/bin/mkdir", "-p", "/var/db/openldap-xbone-slurpd"; 
    system "/bin/mkdir", "-p", "/var/db/openldap-xbone-data"; 
    system "/bin/mkdir", "-p", "/var/run/openldap-xbone"; 
};

sub fixperms {
    system "chown", "-R", "ldap:ldap", "/var/db/openldap-xbone-slurpd"; 
    system "chown", "-R", "ldap:ldap", "/var/db/openldap-xbone-data"; 
    system "chown", "-R", "ldap:ldap", "/var/run/openldap-xbone";
};

sub usage {

    print "Usage: xb-ldap-config  install [local|global]\n";  
    print "       xb-ldap-config  uninstall\n";  
    print "       xb-ldap-config  ldaprc\n"; 
    print "       xb-ldap-config  add <server> <LDIF-file>\n"; 
    print "       xb-ldap-config  show <server> [oid]\n"; 
    print "       xb-ldap-config  delete <server> [oid]\n\n"; 
    print "(un)install: (un)install X-Bone specific components\n";
    print "ldaprc     : create ldaprc in the home directory \n";
    print "add        : add the contents of an LDIF file\n";
    print "show       : show the contents of the tree under oid\n";
    print "delete     : delete the tree under oid\n";
    print "\nWhere unspecified, default oid=\"ou=xbone\".\n"; 
    print "Install and uninstall are executed assuming that".
   	  " the server\nis on the local machine\n\n";
    exit;
}

#=> main 
# => process 
eval { 
    
    die "cmd" if ($#ARGV < 0);

    # read the variables to begin with 
    read_xbone_conf; 

    $_ = $ARGV[0];    
    SWITCH: { 
      
      ( /^(install)$/i) and do {	  

	  my $scope = $ARGV[1]; 
	  if (not defined $scope) { $scope = "local"; }
	  if (  $scope eq "local" ) {
	      $replacement{"GXBONE"} = "#";  
	  } elsif ($scope eq "global" ) {
	      $replacement{"GXBONE"} = "";  
	  } else {	
	      die "cmd";	      
	  }
	  
	  write_openldap; 
	  write_ldaprc; 
	  slapd_daemon("stop");
	  cleanup_slapdb();
	  create_slapdb();
	  slapd_conf_modify("add");
	  slapd_init($slavelocalldif, "ou=local,ou=xbone"); 
	  slapd_init($slavegloballdif,"ou=global,ou=xbone"); 
	  fixperms();
	  slapd_daemon("start");
	  last SWITCH; 
      }; 
      
      (/^(uninstall)$/i) and do {	  
	  slapd_daemon("stop");
	  slapd_conf_modify("del");
	  #if ( -e $xboneslapconf) { unlink $xboneslapconf; } 
	  cleanup_slapdb();
	  slapd_daemon("start");
	  last SWITCH; 
       };
      
      (/^(add)$/i) and do {	  
	  die "cmd" if ($#ARGV < 2);
          verify_ldaprc(); 
	  slapd_add($ARGV[1], $ARGV[2]); 	  
	  last SWITCH;
      };

      (/^(show)$/i) and do {	  
	  die "cmd" if ($#ARGV < 1);
	  die "cmd" if (defined $ARGV[2] and $ARGV[2] !~ /(ou=xbone)/); # sanity check
          verify_ldaprc(); 
	  slapd_show($ARGV[1], $ARGV[2]); 	  
	  last SWITCH;
      };

      (/^(init)$/i) and do {	  
	  my $what = "slave"; 
	  if (defined $ARGV[1] and $ARGV[1] =~ /xbone/){
	      $what = "xbone"; 
	  }
	  slapd_daemon("stop");
	  cleanup_slapdb();
          create_slapdb(); 
	  if ($what eq "slave"){ 
	      slapd_init($slavelocalldif, "ou=local,ou=xbone"); 
	      slapd_init($slavegloballdif,"ou=global,ou=xbone"); 
	  } else {
	      slapd_init($xbonelocalldif, "ou=local,ou=xbone"); 
	      slapd_init($xbonegloballdif,"ou=global,ou=xbone"); 
	  }
	  fixperms();
	  slapd_daemon("start");
	  last SWITCH;
      };

      (/^(delete)$/i) and do {	  
	  die "cmd" if ($#ARGV < 1);
	  die "cmd" if ($ARGV[1] =~ /(ou=xbone)/); # sanity check
          verify_ldaprc(); 
	  slapd_delete($ARGV[1], $ARGV[2]); 	  
	  last SWITCH;
      };

      (/^(ldaprc)$/i) and do {	  
	  read_xbone_conf; 
          write_ldaprc("1"); 
	  last SWITCH;
      };
      die "cmd"; 
  };
};


# => Wrapup 
if ($@){ 
   usage() if ($@ =~ /(cmd)/i);
   exit (1); 
}
exit(0); 
