eval '(exit $?0)' && eval 'PERLDB_OPTS="N f=26";export PERLDB_OPTS;PERL=`which perl5`; exec $PERL -wS $0 ${1+"$@"}'
    & eval 'setenv PERLDB_OPTS "N f=26"; setenv PERL `which perl5`; exec $PERL -wS $0 $argv:q'
    if 0;

### Local Variables: ***
### mode:perl ***
### comment-column:0 ***
### comment-start: "### " ***
### comment-end: "***" ***
### End: ***
#
# ****************DO NOT MOVE OR CHANGE LINES ABOVE THIS*********************
#
# The first set of lines runs perl from any shell. The second set of lines
# identifies the rest of the file as PERL for EMACS autoformatting.
# See end of copyright for more information.
#
# 
# -------------------------------------------------------------------
#                                   X-BONE
#
#                          http://www.isi.edu/xbone
#                USC Information Sciences Institute (USC/ISI)
#                   Marina del Rey, California 90292, USA
#                          Copyright (c) 1998-2005
# 
# -------------------------------------------------------------------
#
# Copyright (c) 1998-2005 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation in source and binary forms for non-commercial
# purposes and without fee is hereby granted, provided that the above
# copyright notice appear in all copies and that both the copyright
# notice and this permission notice appear in supporting
# documentation, and that any documentation, advertising materials,
# and other materials related to such distribution and use acknowledge
# that the software was developed by the University of Southern
# California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived
# from this software without specific prior written permission.
# 
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT
# THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS
# PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so
# noted when applicable.
#
# -------------------------------------------------------------------
#
# Effort partly sponsored by the Defense Advanced Research Projects
# Agency (DARPA) and Air Force Research Laboratory, Air Force Materiel
# Command, USAF, under agreement numbers F30602-98-1-0200 (X-Bone) and
# F30602-01-2-0529 (DynaBone). The views and conclusions contained
# herein are those of the authors and should not be interpreted as
# necessarily representing the official policies or endorsements,
# either expressed or implied, of the Defense Advanced Research
# Projects Agency (DARPA), the Air Force Research Laboratory, or the
# U.S. Government.
#
# This work was partly supported by the NSF STI-XTEND (ANI-0230789)
# and NETFS (ANI-0129689) projects. Any opinions, findings, and
# conclusions or recommendations expressed in this material are those
# of the authors and do not necessarily reflect the views of the
# National Science Foundation.
#
# -------------------------------------------------------------------
#  $RCSfile: xb-apache-config.pl,v $
#
# $Revision: 1.8 $
#   $Author: pingali $
#     $Date: 2005/04/08 22:31:40 $
#    $State: Exp $
# ----------------------------------------------------------------------------
#
############################################################
#
# The first lines start PERL on any system where perl is in the path.
# This is a modified version of the "start perl" script
# provided in the PERL man pages, which starts perl
# on the remainder of the file regardless of whether it
# is run under sh, csh, or perl.
#
# This version is modified to dynamically locate the
# perl path, rather than requiring it be hard-coded.
#
# setenv PERLDB_OPTS "N f=26"
#
# Must be set before perl starts!
#
# N 	: Nonstop (noninteractive)
# f=26	: frame=26 = 16 + 8 + 2,
#		2 = entry and exit,
#		!4 = don't print args to functions
#		8= enabled overloaded stringify and tied FETCH
#		16= print return values from subroutines
#
# note - '-T' (TAINT) switch is not included, because 'which' often
# returns a version of perl that isn't secure. don't worry about it.
#
############################################################
# PERL CODE STARTS HERE
############################################################

# 
# xb-apache-config.pl installs or uninstalls xbone-specific
# apache configuration file. 
#

use strict;
use sigtrap;

use Data::Dumper;
use Cwd;
use FindBin; 

my $ldir = $FindBin::RealBin;
my $conf = "/usr/local/etc/xbone/xbone-gui.conf";
my $file = "/usr/local/etc/xbone/apache/xbone-apache.conf";
my $template = "/usr/local/etc/xbone/apache/xbone-apache.conf.template";
my ($include, $apachectl); 

# => Variables....
my  %xbonevars = ( 
		"ca_cert" =>  "",
		"ca_path" =>  "",
		"node_cert" => "",
		"node_key" => "",
		);

# Set the correct output conf file. 
my $os = `uname -s`; chomp($os); 
my $host = `uname -n`; chomp($host); 
if ( $os =~ /linux/i){ 
    $include = "/etc/httpd/conf.d/xbone-apache.conf"; 
} else { 
    $include = "/usr/local/etc/apache2/Includes/xbone-apache.conf"; 
}

# Find where apachectl is installed. 
my ($found) = (0, ""); 
my @path = ("/bin", "/sbin","/usr/bin","/usr/sbin",
	    "/usr/local/bin","/usr/local/sbin",
            split(":", $ENV{PATH}));
foreach my $dir (@path){
    if(-e "$dir/apachectl" and -x "$dir/apachectl" ){ 
	$apachectl = "$dir/apachectl"; 
	last;
    };
}; 
die ("Unable find apachectl") if ($apachectl eq ""); 


# => Extract the variables from the configuration $conf
sub read_xbone_conf {    
    
    my @keys = keys %xbonevars; 
    open (IN, "< $conf" ) || die ("Unable to open $file"); 
    while (<IN>){
	my $line =  $_; 
	chomp($line); 

	my $found = 0; 
	foreach my $key (@keys){
	    if ( $line =~ /$key/ ) { 
		$found = 1; 
		last; 
	    }
	}

	next if ($found == 0); 

	my @components = split (/\s+/, $line); 	
	if ( defined $xbonevars{$components[0]} ){
	    $xbonevars{$components[0]} = $components[2]; 
	}	
    }
    close(IN); 
    
}; 


# Write out the apache file. 
sub write_apache {


    my %replacement = ( 
			"TLSCACERTFILE" => $xbonevars{ca_cert},
			"TLSCACERTPATH" => $xbonevars{ca_path},
			"TLSCERTFILE" => $xbonevars{node_cert},
			"TLSKEYFILE" => $xbonevars{node_key},
			"BASEPORT"	=> 8000, 
			"CTLPORT"	=> 8001, 
			);

    my @keys = keys %replacement; 

    open( IN, "< $template") || die ("Unable to open $template for reading"); 
    open( OUT, "> $file") || die ("Unable to open $file for writing"); 

    while (<IN>){
	my $line = $_; 
	if ( $line !~ /EXPORT/) { 
	    foreach my $key (@keys){
	        $line =~ s/$key/$replacement{$key}/; 
	    };
	}
	
	print OUT $line;
    };
    
    close IN; 
    close OUT; 
};


# => Install/uninstall apache 
sub install_apache {
    
    if ( -e $include ) { unlink $include; }
    system ($apachectl, 'stop') == 0 || die("install"); 
    system ('/bin/ln', '-s', $file, $include) == 0 || 
	die("install"); 
    sleep(2); 
    system ($apachectl, 'startssl') == 0 || die("install"); 

}; 

sub uninstall_apache {
    
    system ($apachectl, 'stop')  == 0 || 
	die("uninstall");
    if ( -e $include ) { unlink $include; } 
    if ( -e $file ) { unlink $file;  } 
    sleep(2); 
    system ($apachectl, 'startssl') == 0 || 
	die ("uninstall"); 
    
};



#=> main 
$_ = $ARGV[0]; 

eval { 
    
    if (not defined or ! /^(install|uninstall)$/ ) { 
	print "Usage: xb-apache-config.pl  [install|uninstall]\n"; 
	die("cmd"); 
    } elsif ( /^(install)$/i ){
	read_xbone_conf; 
	write_apache; 
	install_apache; 
	print "\nVisit http://$host:8000 to view X-Bone GUI\n"; 
    } elsif ( /^(uninstall)$/i ) {
	uninstall_apache; 
    };
};
if ($@) {
    exit(1); 
}
    
# => Wrapup 
exit (0);

