# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

use lib './blib/lib','./blib/arch';

BEGIN { $| = 1; print "1..14\n"; }
END {print "not ok 1\n" unless $loaded;}

use IO::Interface 0.94 'IFF_MULTICAST';
use IO::Socket; 
use Socket6; 
use IO::Socket::Multicast6;
use Net::IP; 

$loaded = 1;
print "ok 1\n";

######################### End of black magic.

sub test {
  my ($flag,$test) = @_;
  print $flag ? "ok $test\n" : "not ok $test ($!)\n";
}

my $addr = "FF02:0:0:0:0:0:0:6061";
my $port = 5000;

my $s = IO::Socket::Multicast6->new (LocalPort => $port);

if (not defined $s){
  croak("Could not create a socket");
}

test ($s->mcast_add($addr, 'lo0'), 1);

my $dest = pack_sockaddr_in6($port, inet_pton(AF_INET6, $addr));
my $msg = "TESTTESTTEST"; 

my $sent = $s->mcast_send($msg, $dest);
test ($sent == length($msg), 2); 
test ($s->mcast_drop($addr) > 0,    3);
test (!$s->mcast_drop($addr),   4);
test ($s->mcast_ttl         == 1,     5);
test ($s->mcast_ttl(10)     == 1,     6);
test ($s->mcast_ttl         == 10,    7);
test ($s->mcast_loopback    == 1,     8);
test ($s->mcast_loopback(0) == 1,     9);
test ($s->mcast_loopback    == 0,    10);

